首页 > 编程语言 > 详细

java异常:try、catch、finally、throw、throws以及自定义异常类

时间:2021-09-10 00:20:11      阅读:7      评论:0      收藏:0      [点我收藏+]

java异常

概念

什么是异常

  • 实际生活中,遇到的情况不可能是非常完美的。比如:你写的某个模块,用户输入不符合你的要求,你的程序要打开某个文件,这个文件可能不存在或者文件格式不对,你要读取数据库的数据,数据可能是空的。我们程序跑着跑着,内存可能满了。等等
  • 软件程序在运行过程中,非常可能遇到刚刚提到的这些异常问题,我们叫异常,英文是:Exception,意思是例外。这些例外情况,怎么让我们写的程序作出合理的处理,而不至于程序崩溃
  • 异常是指程序运行中出现的不期而至的各种状况,如:文件找不到、网络连接失败、非法参数等。
  • 异常发生在程序运行期间,他影响了正常的程序执行流程

简单分类

  • 要理解java异常处理是如何进行工作的,要掌握以下三种类型的异常:
  • 检查性异常:最具代表的检查性异常是用户错误或问题引起的异常,这是程序员无法预见的,例如打开一个不存在的文件时,一个异常就发生了,这些异常在编译时不能被简单地忽略
  • 运行时异常:运行时异常可能是程序员避免的异常。与检查性异常相反,运行时异常可以在编译时被忽略
  • 错误:错误不是异常,而是脱离程序员控制的问题。错误在代码中经常被忽略。例如,当栈溢出时,一个错误就发生了,他们在编译也检查不到的

异常体系结构

  • java把异常当做对象来处理,并定义一个基类java.lang.Throwable作为所有异常的超类
  • 在Java API中已经定义了很多异常类,这些异常分为两大类,错误Error和异常Exception

技术分享图片

Error与Exception

Error

  • Error类对象由java虚拟机生成并抛出,大多数错误与代码编写者所执行的操作无关
  • Java虚拟机运行错误(Virtual MachineError),当JVM不再有继续执行操作所需的内存资源时,将出现OutOfMemoryError。这些异常发生时,Java虚拟机(JVM)一般会选择线程终止
  • 还有发生在虚拟机试图执行应用时,如定义错误(NoClassDefFoundError)、链接错误(LinkageError)。这些错误是不可查的,因为他们在应用程序的控制和处理能力之外,而且绝大多数是程序运行时不允许出现的状况

Exception

  • 在Exception分支中有一个重要的子类RuntimeException(运行时异常)

    • ArrayIndexOutOfBoundsException(数组下标越界)
    • NullPointerException(空指针异常)
    • ArithmeticException(算数异常)
    • MissingResourceException(丢失资源)
    • ClassNotFountException(找不到类)等异常,这些异常是不检查异常,程序可以选择捕获处理,也可以不处理
  • 这些已成一般是有程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生;

  • Error和Exception的区别:Error通常是灾难性的致命错误,是程序无法控制和处理的,当出现这些异常时,Java虚拟机(JVM)一般会选择终止线程;Exception通常情况下是可以被程序处理的,并且在陈旭中应该尽可能的去处理这些异常

异常处理机制

  • 抛出异常
  • 捕获异常

异常处理的五个关键字:

  • try (该代码块中写的是 可能会出异常的代码)
  • catch (捕获住异常之后 执行的代码)
  • finally (不管是否发生了异常 最终一定会执行的代码(除了 System.exit(0)))
  • throw (用在方法中 用来主动抛出异常)
  • throws (用在方法上 声明抛出异常)
package com.exception;
/**
 * 异常
 */
public class Demo1 {
    public static void main(String[] args) {
        int x=1;
        int y=0;
        try {//可能会有出异常的代码
           new Demo1().aa();
        }catch (ArithmeticException e){//捕获到异常 后执行的代码
            //可以有多个catch去捕获 但是较大的异常要放在后面 多个catch只会执行一个 和if else if类似
            System.out.println("算数异常");
            e.printStackTrace();//打印栈信息
        }catch (Error e){
             // System.exit(0);//终止程序
            System.out.println("Error");
        } catch (Exception e){
            System.out.println("Exception");
        }catch (Throwable e){
            System.out.println("Throwable");
        }finally { //不管是否发生异常 最终一定会执行的代码
            System.out.println("finally");
        }
    }
    public void aa(){
        bb();
    }
    public void bb(){
        aa();
    }
    public void cc() throws ArithmeticException{
        throw new ArithmeticException();
    }
}

自定义异常

  • 使用Java内置的异常类可以描述在编程时出现的大部分异常情况。除此之外,用户还可以自定义异常。用户自定义异常类,只需继承Exception类即可

  • 在程序中自定义异常类,大体可分为以下几个步骤:

    • 创建自定义异常类
    • 在方法中通过throw关键字抛出异常对象
    • 如果在当前抛出异常的方法中处理异常,可以使用try-catch语句捕获并处理;否则在方法的声明通过throws关键字指明要抛出给方法调用者的异常,继续下一步操作
    • 在出现异常方法的调用者中捕获并处理异常
package com.exception;
/**
 * 自定义异常类
 */
public class MyException extends Exception {
    private String message;

    public MyException(String message) {
       this.message=message;
    }

    @Override
    public String toString() {
        return message;
    }
}

package com.exception;

public class Test {
    public static void main(String[] args) {
        int age=-100;
            if(age>120||age<0){
               test();
            }
    }
    public static void test(){
        try {
            throw new MyException("年龄不规范");
        } catch (MyException e) {
            System.out.println(e);
        }
    }

}

实际应用中的经验总结

  • 处理运行时异常时,采用逻辑去合理规避同时辅助try-catch处理
  • 在多重catch块后面,可以加一个catch(Exception)来处理可能被遗漏的异常
  • 对于不确定的代码,也可以加上try-catch,处理潜在的异常
  • 尽量去处理异常,切忌只是简单地调用printStackTrace()去打印输出
  • 具体如何处理异常,要根据不同的业务需求和异常类型去决定
  • 尽量添加finally语句块去释放占用的资源

到此java基础已经学完了,这一块偏理论的东西比较多,好好消化一下,学无止境,加油!

java异常:try、catch、finally、throw、throws以及自定义异常类

原文:https://www.cnblogs.com/ljhStudy/p/15246451.html

(0)
(0)
   
举报
评论 一句话评论(0
© 2014 bubuko.com 版权所有
打开技术之扣,分享程序人生!